<template>
	<div
		:class="[$style.promoBar, $style[promoBar.themeLowerCase], { [$style.spacer]: spacer }]"
		:style="{ color: colors.text, backgroundColor: colors.background }"
		data-rich-content-atc-source="banner"
		@click="toggleOnClick"
	>
		<GlobalEvents target="window" @resize="debouncedResize" />

		<div :class="$style.inner" :style="{ paddingRight: `${scrollBarWidth}px` }">
			<div :class="[$style.layer, $style.closed]">
				<div ref="collapsedInner" :class="$style.closedInner">
					<div
						v-if="hasButton && promoBar.expandedCtaShowWhenCollapsed === 'Yes'"
						ref="collapsedButtonFirst"
						:class="$style.closedButtonWrapper"
					>
						&nbsp;
					</div>
					<div
						v-if="collapsedImageWidth"
						ref="collapsedImage"
						:class="$style.closedImageWrapper"
						:style="{ width: collapsedImageWidth }"
					>
						<BaseImage
							:image="null"
							:images="{ medium: promoBar.collapsedImage }"
							:sizes="collapsedImageWidth"
							compression-level="high"
							critical
						/>
					</div>
					<div
						v-if="promoBar.mainContentMobile && promoBar.mainContentMobile.length"
						v-rich-content
						:class="[$style.main, $style.mobile]"
						v-html="mainContentMobile"
					></div>
					<div
						v-if="promoBar.mainContent && promoBar.mainContent.length"
						ref="collapsedMainDesktop"
						v-rich-content
						:class="[$style.main, $style.desktop]"
						v-html="mainContent"
					></div>
					<div
						v-if="hasButton && promoBar.expandedCtaShowWhenCollapsed === 'Yes'"
						ref="collapsedButton"
						:class="$style.closedButtonWrapper"
						:style="{ color: colors.button.text }"
					>
						<BaseButtonArrow
							:smart="promoBar.expandedCtaLink.url"
							:class="$style.arrowLink"
							add-to-cart-source="banner"
						>
							{{ promoBar.expandedCtaText || promoBar.expandedCtaLink.url }}
						</BaseButtonArrow>
					</div>
				</div>
			</div>
			<div
				:class="[
					$style.layer,
					$style.open,
					{ [$style.initiallyCollapsed]: !hasExpandedImage && useInitiallyCollapsedClass },
				]"
			>
				<div ref="heightAnimator" :class="$style.expandedAnimator" @transitionend.self="transitionEnd">
					<div
						ref="expandedAnimatorInner"
						:class="[$style.expandedAnimatorInner, $style.posRel]"
						:style="{ backgroundColor: colors.background }"
					>
						<div :class="$style.expandedWrapper">
							<div :class="$style.expandedLayers">
								<div :class="[$style.expandedLayer, $style.image]">
									<BaseImage
										:image="null"
										:images="{ medium: promoBar.expandedImage }"
										sizes="(min-width: 800px) 800px, 100vw"
										critical
										compression-level="high"
									/>
								</div>
								<div :class="[$style.expandedLayer, $style.content]">
									<div :class="$style.expandedContentInner">
										<div :class="$style.mainWrapper">
											<div
												v-if="promoBar.mainContent && promoBar.mainContent.length"
												v-rich-content
												:class="$style.main"
												v-html="mainContent"
											></div>
										</div>
									</div>
								</div>
							</div>
						</div>

						<BaseButton
							v-if="hasButton"
							:smart="promoBar.expandedCtaLink.url"
							size="medium"
							appearance="custom"
							force-color
							:custom-appearance="colors.button"
							:class="$style.expandedButton"
							add-to-cart-source="banner"
						>
							{{ promoBar.expandedCtaText || promoBar.expandedCtaLink.url }}
						</BaseButton>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import debounce from 'lodash/debounce';
import { mapState } from 'vuex';

const layout = (el) => window.getComputedStyle(el).transform;
const px = (val) => `${val}px`;

let spacer;
let wasExpanded = false;

const isButtonOrLink = (e) => e.target.matches('a, button, a *, button *');
const hasExpandedImage = (vm) => Boolean(vm.promoBar.expandedImage && vm.promoBar.expandedImage.url);

const CLOSE_DELAY = 5000;
const TRANISTION_TIME = 1000;

export default {
	props: {
		spacer: {
			type: Boolean,
			default: false,
		},

		promoBar: {
			type: Object,
			required: true,
		},

		scrollBarWidth: {
			type: Number,
			default: 0,
		},
	},

	data() {
		return {
			isExpanded: hasExpandedImage(this),
			debouncedResize: debounce(this.handleResize, 100),
			useInitiallyCollapsedClass: true,
		};
	},

	computed: {
		...mapState('screen', ['medium']),

		mainContent() {
			// https://www.oreilly.com/library/view/regular-expressions-cookbook/9780596802837/ch08s02.html
			return this.promoBar.mainContent.replace(
				/<(\/?)h(\d+)\b((?:[^>"']|"[^"]*"|'[^']*')*)>/gi,
				(_, close, level, attrs) => `<${close}strong data-level="${level}" ${attrs}>`
			);
		},

		mainContentMobile() {
			// https://www.oreilly.com/library/view/regular-expressions-cookbook/9780596802837/ch08s02.html
			return this.promoBar.mainContentMobile.replace(
				/<(\/?)h(\d+)\b((?:[^>"']|"[^"]*"|'[^']*')*)>/gi,
				(_, close, level, attrs) => `<${close}strong data-level="${level}" ${attrs}>`
			);
		},

		hasButton() {
			return this.promoBar.expandedCtaLink && this.promoBar.expandedCtaLink.url;
		},

		hasExpandedImage() {
			return hasExpandedImage(this);
		},

		colors() {
			const { promoBar } = this;
			return {
				background: promoBar.backgroundColor || '#333',
				text: promoBar.textColor || '#fff',
				button: {
					background: promoBar.ctaBackgroundColor || '#7befb2',
					backgroundHover: promoBar.ctaBackgroundHoverColor || '#7befb2',
					text: promoBar.ctaTextColor || '#000',
				},
			};
		},

		collapsedImageWidth() {
			const { collapsedImage } = this.promoBar;
			if (!(collapsedImage && collapsedImage.url)) return '';
			return `${(35 / collapsedImage.height) * collapsedImage.width}px`;
		},
	},

	mounted() {
		if (this.spacer) {
			spacer = this;
		}

		if (this.medium && this.isExpanded && !wasExpanded) {
			this.collapseAfterDelay();
		} else {
			this.isExpanded = false;
			const { heightAnimator, expandedAnimatorInner } = this.$refs;
			heightAnimator.style.height = '0';
			heightAnimator.parentElement.style.visibility = 'hidden';
			expandedAnimatorInner.style.opacity = '0';
			if (this.medium) this.adjustCollapsedClasses();
		}

		this.useInitiallyCollapsedClass = false;
	},

	methods: {
		expand() {
			if (this.isExpanded || !this.medium) return;
			if (!this.hasExpandedImage) return;
			if (!this.spacer) spacer.expand();
			const { heightAnimator, expandedAnimatorInner } = this.$refs;
			if (!(heightAnimator && expandedAnimatorInner)) return;
			const currentHeight = heightAnimator.parentElement.offsetHeight;
			heightAnimator.style.height = '';
			heightAnimator.style.transition = 'none';
			const fullHeight = heightAnimator.offsetHeight;
			heightAnimator.style.height = px(currentHeight);
			heightAnimator.parentElement.style.visibility = '';
			expandedAnimatorInner.style.opacity = '1';
			layout(heightAnimator);
			heightAnimator.style.transition = '';
			heightAnimator.style.height = px(fullHeight);
			this.isExpanded = true;
			this.collapseAfterDelay(CLOSE_DELAY + TRANISTION_TIME);
		},

		collapse() {
			if (!this.isExpanded) return;
			if (!this.spacer) spacer.collapse();
			if (this.collapseTimeout) clearTimeout(this.collapseTimeout);
			this.adjustCollapsedClasses();
			const { heightAnimator, expandedAnimatorInner } = this.$refs;
			const currentHeight = heightAnimator.offsetHeight;
			heightAnimator.style.transition = 'none';
			heightAnimator.style.height = px(0);
			const targetHeight = heightAnimator.parentElement.offsetHeight;
			heightAnimator.style.height = px(currentHeight);
			layout(heightAnimator);
			heightAnimator.style.transition = '';
			heightAnimator.style.height = px(targetHeight);
			expandedAnimatorInner.style.opacity = '0';
			this.isExpanded = false;
			wasExpanded = true;
		},

		adjustCollapsedClasses() {
			const {
				collapsedInner,
				collapsedImage,
				collapsedButtonFirst,
				collapsedButton,
				collapsedMainDesktop,
			} = this.$refs;
			if (!collapsedMainDesktop) return;
			const absoluteButtonRight = 20;
			const wrapperImageClass = this.$style.wrappedImage;
			const wrapperButtonClass = this.$style.wrappedButton;
			const absoluteClass = this.$style.absolute;
			collapsedInner.classList.remove(wrapperImageClass);
			collapsedInner.classList.remove(wrapperButtonClass);
			if (collapsedButtonFirst) collapsedButtonFirst.style.display = 'none';
			if (collapsedButton) collapsedButton.classList.remove(absoluteClass);
			layout(collapsedInner);
			const { top: containerTop } = collapsedMainDesktop.getBoundingClientRect();

			if (collapsedImage) {
				const { top } = collapsedImage.getBoundingClientRect();
				if (top !== containerTop) {
					collapsedInner.classList.add(wrapperImageClass);
				}
			}

			if (collapsedButton && collapsedButtonFirst) {
				const { top, width } = collapsedButton.getBoundingClientRect();
				if (top !== containerTop) {
					collapsedInner.classList.add(wrapperButtonClass);
				} else {
					collapsedButtonFirst.style.display = 'block';
					collapsedButtonFirst.style.width = `${width + absoluteButtonRight * 2}px`;
					const { top: topWithFirst } = collapsedButton.getBoundingClientRect();
					if (topWithFirst === containerTop) {
						// there is enough space for absolute button
						collapsedButton.classList.add(absoluteClass);
						collapsedButton.style.right = `${absoluteButtonRight}px`;
					}
					collapsedButtonFirst.style.display = 'none';
				}
			}

			layout(collapsedInner);
		},

		handleResize() {
			this.adjustCollapsedClasses();
		},

		collapseAfterDelay(time = CLOSE_DELAY) {
			if (!this.spacer) {
				this.collapseTimeout = setTimeout(this.collapse, time);
			}
		},

		toggle() {
			this[this.isExpanded ? 'collapse' : 'expand']();
		},

		toggleOnClick(e) {
			if (isButtonOrLink(e)) return;
			this.toggle();
		},

		transitionEnd() {
			const { heightAnimator, expandedAnimatorInner } = this.$refs;

			if (this.isExpanded) {
				heightAnimator.style.height = '';
				expandedAnimatorInner.style.opacity = '';
			} else {
				heightAnimator.style.height = '0';
				heightAnimator.parentElement.style.visibility = 'hidden';
			}

			this.$emit('change');
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.promoBar {
	position: relative;
	z-index: 2;
	padding: 0 size('s');
	overflow: hidden;
	text-align: left;
	pointer-events: auto;
}

.inner {
	display: flex;
}

.layer {
	position: relative;
	flex: 0 0 auto;
	width: 100%;
	margin-right: -100%;

	&.posRel {
		position: relative;
	}

	&.open {
		z-index: 1;
	}

	&.closed {
		padding: size('xxs') 0;

		@include above('medium') {
			padding: size('xs') 0;
		}
	}
}

.closedInner {
	position: relative;
	display: flex;
	flex-wrap: wrap;
	justify-content: center;
}

.main {
	display: flex;

	@include use-text-style('type-100');

	a {
		color: inherit;
		text-decoration: underline;
	}

	strong[data-level='4'] {
		display: block;
		width: 20rem;
		font-weight: normal;

		@include font-family('secondary');
		@include use-text-style('type-200');

		@include above('medium') {
			@include use-text-style('heading-180');

			width: auto;
			margin-right: 1rem;
		}

		.open & {
			margin-bottom: size('base');
		}
	}

	strong[data-level='5'] {
		font-size: 1.8rem;
		font-weight: 400;

		.open & {
			display: block;
			margin-bottom: size('base');
		}

		.closed & {
			@include above('medium') {
				position: relative;
				top: -0.4rem;
			}
		}
	}

	p {
		font-weight: 300;
		line-height: 1.48572;
		.closed & {
			@include above('medium') {
				position: relative;

				@include use-text-style('heading-100');
			}
		}
		.open & {
			@include use-text-style('heading-100');
		}

		@include above('medium') {
			line-height: 1.3;
		}
	}

	> * > a:only-child {
		text-decoration: none;
	}

	.closed & {
		display: flex;

		> * {
			display: inline;

			&:not(:last-child)::after {
				content: ' ';
			}
		}
	}

	&.desktop {
		align-items: center;

		@include below('medium') {
			display: none;
		}
	}

	&.mobile {
		@include above('medium') {
			display: none;
		}
	}
	.expandedContentInner & {
		flex-direction: column;
		max-width: 36rem;
		margin-right: 2rem;
	}
}

.closedImageWrapper {
	box-sizing: content-box;
	padding-right: size('l');

	@include below('medium') {
		display: none;
	}

	.wrappedImage & {
		padding-bottom: size('base');
		padding-left: size('l');
	}
}

.closedButtonWrapper {
	display: inline-flex;
	flex: 0 0 auto;
	align-items: center;
	min-height: 100%;
	padding-left: size('xxs');
	text-align: right;

	@include below('medium') {
		display: none;
	}

	&.absolute {
		position: absolute;
		top: 0;
	}

	.wrappedButton & {
		padding-top: size('base');
		padding-right: size('xxs');
	}
}

.arrowLink {
	@include below('xlarge') {
		[class*='left'] {
			display: none;
		}
	}
}

.expandedAnimator {
	transition: height 1s;

	@include below('medium') {
		display: none;
	}
}

.expandedAnimatorInner {
	opacity: 1;
	transition: opacity 1s;
}

.initiallyCollapsed {
	visibility: hidden;

	.expandedAnimator {
		height: 0;
	}

	.expandedAnimatorInner {
		opacity: 0;
	}
}

.expandedWrapper {
	max-width: 80rem;
	margin: 0 auto;
}

.expandedLayers {
	display: flex;
}

.expandedLayer {
	position: relative;
	flex: 0 0 auto;
	width: 100%;
	margin-right: -100%;

	&.image {
		align-self: flex-end;
	}

	&.content {
		display: flex;
		align-items: center;
	}
}

.expandedContentInner {
	display: flex;
	flex: 0 0 auto;
	align-items: center;
	justify-content: center;
	width: 100%;
	margin-left: 2.5rem;
}

.expandedButton {
	position: absolute !important;
	top: 3.2rem;
	right: 1.9rem;
}
</style>
